#include <fstream.h>
#include <string.h>

int N;
int tab[30][300];
int t[30];
int tt[30];

void trans(int n) {
    int i=1,j,w=tt[n];
    while (i*w<20) {
	tab[n][i*w]=0;
	for (j=2;j<=20-i*w;j++) 
	  if (!tab[n][j]&&tab[n][j+i*w]) {
	     tab[n][j+i*w]=0;
//	     cout<<w<<":"<<j<<"zer"<<j+i*w<<"i"<<i<<endl;
	     }
	i++;
    }
}

const int bit[23]={
0,0,1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768,65536,131072,262144,524288,1048576
};

int tab2int (int n) {
    int l=0,i;
    for (i=1;i<=20;i++) if (tab[n][i]==1) l+=bit[i];
    return l;
}

int wass;

void prin(int n) {
    if (!wass) cout<<"The winning moves are: ";
    wass=1;
    cout<<n<<" ";
}

int was[30];

int chk(int lst) {
    int i,j,tmp;
    
    for (i=2;i<=N;i++)
    if (!was[i]&&t[i]!=0&&(lst&t[i]==0)) return 1;
    else {
	was[i]=1; tmp=lst&t[i];
	for (j=2;j<=N;j++) if (!was[j]&&t[j]!=0&&(tmp&t[j]==0)) break;
	if (j<=N&&!(!was[j]&&t[j]!=0&&(tmp&t[j]==0))) {
	    was[j]=1;
	    if (chk(tmp&t[j])) return 1;
	    was[j]=0;
	}
	was[i]=0;
    }
    return 0;
}

int win(int n) {
    if (tab[0][n]==0) return 0;
//    return 1;
    if (t[n]==0) return 1;
    
    memset(was,0,sizeof(was));
    was[n]=1;
    
    int i,j,tmp;
    
    for (i=2;i<=N;i++) 
    if (!was[i]&&t[i]!=0&&(t[n]&t[i]==0)) return 1;
    else {
    cout<<i;
	was[i]=1; tmp=t[n]&t[i];
	for (j=2;j<=N;j++) if (!was[j]&&t[j]!=0&&(tmp&t[j]==0)) break;
	if (j<=N&&!(!was[j]&&t[j]!=0&&(tmp&t[j]==0))) {
	    was[j]=1;
	    if (chk(tmp&t[j])) return 1;
	    was[j]=0;
	}
	was[i]=0;
    }
    return 0;
}

int main () {
    ifstream fin("numbergame.in");
    
    int i,j,x,T=1;
    
    fin>>N;
    while (N!=0) {
	cout<<"Test case #"<<T++<<endl;
	for (i=0;i<=20;i++) tab[0][i]=0;
	for (i=1;i<=N;i++) { fin>>x; tt[i]=x; tab[0][x]=1; }
	for (i=1;i<=N;i++) for (j=0;j<=20;j++) tab[i][j]=tab[0][j];
	
	for (i=1;i<=N;i++) trans(i);
	memset(t,0,sizeof(t));
	for (i=1;i<=N;i++) t[tt[i]]=tab2int(i);
	
//	for (i=1;i<=20;i++) cout<<i<<":"<<t[i]<<endl;
	
	wass=0;
	for (i=2;i<=20;i++) if (win(i)) prin(i);
	if (!wass) cout<<"There's no winning move.";
	
	cout<<"\n\n";
	fin>>N;
    }
    
    fin.close();
    return 0;
}
